<?xml version="1.0"?>
<!-- 
  VCard4J is a VCard (RFC 2426) parser offering a Java API.
  Copyright (C) 2002-2003 Yann Duponchel. All rights reserved.
  
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:variable name="address-book-url" select="'http://localhost/AddressBook'"/>
  <xsl:variable name="default-destination" select="7100536"/>

  <xsl:template match="/">
    <html>
      <head>
	<title>Appels Telephoniques</title>
	<meta http-equiv="pragma" content="no-cache"/>
	<meta http-equiv="expires" content="0"/>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
	<meta name="Author" content="duponchel@sourceforge.net (Yann)"/>
	<!-- <link rel="stylesheet" type="text/css" href="yann.css" title="style"/> -->
      </head>      
      <body text="#FFFFFF" bgcolor="#000000" link="#FFFFFF" alink="#FFFFFF" vlink="#FFFFFF">
        <font face="Arial, Helvetica"/>
        <div align="center">
          <h1>Appels Telephoniques</h1>
          <br/>
	  <table border="0">
	    <thead>
	      <tr bgcolor="#555555" align="center">
		<th>Date</th>
		<th>Source</th>
		<th>Nom</th>
		<th>Destination</th>
	      </tr>
	    </thead>
	    <tbody>
	      <xsl:apply-templates select="//call"/>
	    </tbody>
	  </table>
	</div>
      </body> 
    </html> 
  </xsl:template>

  <xsl:template match="call">
    <tr bgcolor="#333333" align="center">

      <!-- Date -->
      <td>
	<xsl:value-of select="@date"/>
      </td>
      
      <!-- Source -->
      <td>
      	<xsl:value-of select="@source"/>
      </td>

      <!-- Name -->
      <td> 
        <xsl:for-each select="sourceInfo">
	  <xsl:variable name="fn" select="@fn"/>
	  <xsl:variable name="vcard" select="//addressBook/vcard[type[@name='FN']/value/text/text()=$fn]"/>
	  <xsl:call-template name="NAME">
	    <xsl:with-param name="vcard" select="$vcard"/>
	  </xsl:call-template>
	  <xsl:call-template name="EMAIL">
	    <xsl:with-param name="vcard" select="$vcard"/>
	  </xsl:call-template>
	  <xsl:if test="count(following-sibling::sourceInfo)>0">
	    <xsl:text>, </xsl:text>
	  </xsl:if>
        </xsl:for-each>
      </td>

      <!-- Destination -->
      <td>
	<xsl:if test="not(@destination=$default-destination)">
      	  <xsl:value-of select="@destination"/>
	</xsl:if>
      </td>

    </tr>
  </xsl:template>
  
  <!-- Name -->
  <xsl:template name="NAME">
    <xsl:param name="vcard" />
    <xsl:variable name="fn" select="$vcard/type[@name='FN']/value/text/text()"/>
    <xsl:variable name="name">
      <xsl:choose>
        <xsl:when test="string-length($vcard/type[@name='NICKNAME']/value/listItem/text/text())>0">
	  <xsl:value-of select="$vcard/type[@name='NICKNAME']/value/listItem/text/text()"/>
        </xsl:when>
        <xsl:otherwise>
	  <xsl:value-of select="$vcard/type[@name='N']/value/structuredItem[2]/listItem/text/text()"/>
	  <xsl:text> </xsl:text>
	  <xsl:value-of select="$vcard/type[@name='N']/value/structuredItem[1]/listItem/text/text()"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:choose>
      <xsl:when test="string-length($address-book-url)>0">
        <a href="{$address-book-url}?FN={$fn}">
	  <xsl:value-of select="$name"/>
        </a>
      </xsl:when>
      <xsl:otherwise>
	<xsl:value-of select="$name"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- E-Mail -->
  <xsl:template name="EMAIL">
    <xsl:param name="vcard" />
    <xsl:for-each select="$vcard/type[@name='EMAIL' and count(parameter[@name='TYPE' and @value='INTERNET'])>0]">
      <xsl:variable name="mailto" select="value/text/text()"/>
      <a href="mailto:{$mailto}">
	<img src="mail.png" alt="mail" border="0"/>
      </a>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
